# -*- coding: utf-8 -*-

import nltk
import sys 


if __name__ == '__main__':

  # If no sentence is given for parsing print an explanation.
  if len(sys.argv) == 1:
    print "\nThis is a small parser using a context-free grammar. \nUsage: python smallParser.py \"this is your sentence\"\n" 
    sys.exit(0)
    
  # The grammar used for parsing.
  # This is a very easy solution to solve question 21. This is not a complete German grammar.
  # In order to create a "real" grammar, there have to be way more cases (singular/plural/dativ/nominativ/...).
  grammar1 = nltk.CFG.fromstring(unicode("""
    S -> NP V NP
    V -> "sah" | "isst" | "liebt" | "jagt"
    NP -> "Ted" | "Robin" | "Lily" | Det N
    Det -> "seine" | "die" | "einen" | "der" | "dem"
    N -> "Frau" | "Burger" | "Schirm" | "Salat" | "Bar" | "Maus" | "Katze"
    """, errors = 'replace'))
  
  # The parsing of the input.
  sentence = sys.argv[1].strip().split()
  rd_parser = nltk.ChartParser(grammar1)
  for tree in rd_parser.parse(sentence):
    print(tree)
    
   