# -*- coding: utf-8 -*-

import nltk
import sys 


if __name__ == '__main__':

  # If no sentence is given for parsing print an explanation.
  if len(sys.argv) == 1:
    print "\nThis is a small parser using a context-free grammar. \nUsage: python smallParser.py \"this is your sentence\"\n" 
    sys.exit(0)
    
  # The grammar used for parsing.
  # This is a very easy solution to solve question 21. This is not a complete German grammar.
  # In order to create a "real" grammar, there have to be way more cases (singular/plural/dativ/nominativ/...).
  grammar1 = nltk.CFG.fromstring(unicode("""
    S -> NP_nom VP
    VP -> V NP_acc
    V -> "sah" | "isst" | "liebt" | "jagt"
    NP_nom -> Det_fem_nom N_fem_nom | Det_masc_nom N_masc_nom | "Ted" | "Robin" | "Lily"
    NP_acc -> Det_fem_acc N_fem_acc | Det_masc_acc N_masc_acc | "Ted" | "Robin" | "Lily"
    Det_fem_nom -> "seine" | "die" | "eine"
    Det_masc_nom -> "ein" | "der"
    Det_fem_acc -> "seine" | "die" | "eine" 
    Det_masc_acc -> "seinen" | "einen" | "den"
    N_fem_nom -> "Frau" | "Bar" | "Maus" | "Katze"
    N_masc_nom -> "Burger" | "Schirm" | "Salat" | "Mann"
    N_fem_acc -> "Frau" | "Bar" | "Maus" | "Katze"
    N_masc_acc -> "Burger" | "Schirm" | "Salat" | "Mann" 
    """, errors = 'replace'))
  
  # The parsing of the input.
  sentence = sys.argv[1].strip().split()
  rd_parser = nltk.ChartParser(grammar1)
  for tree in rd_parser.parse(sentence):
    print(tree)
    
   