# -*- coding: utf-8 -*-

import nltk
import sys 


if __name__ == '__main__':

  # If no sentence is given for parsing print an explanation.
  if len(sys.argv) == 1:
    print "\nThis is a small parser using a context-free grammar. \nUsage: python smallParser.py \"this is your sentence\"\n" 
    sys.exit(0)
    
  # The grammar used for parsing.
  grammar1 = nltk.CFG.fromstring(unicode("""
    S -> NP VP | VP2 NP | NP VP_BE 
    VP -> V NP PP | V NP
    VP2 -> NP V
    VP_BE -> V_BE PRED_ADJ
    PP -> P NP
    V -> "sah" | "isst" | "liebt" | "jagt" | "sieht"
    V_BE -> "ist" | "bleibt" | "wird"
    NP -> "Ted" | "Robin" | "Lily" | Det N | Det N PP | Det ADJ N 
    Det -> "seine" | "die" | "eine" | "einen" | "der" | "dem"
    N -> "Frau" | "Bar" | "Maus" | "Katze" | "Burger" | "Schirm" | "Salat"
    ADJ -> "gelben" | "alte" | "nette"
    PRED_ADJ -> "gelb" | "schnell" 
    P -> "in" | "neben" | "mit" | "auf"
    """, errors = 'replace'))
  
  # The parsing of the input.
  sentence = sys.argv[1].strip().split()
  rd_parser = nltk.ChartParser(grammar1)
  for tree in rd_parser.parse(sentence):
    print(tree)
    
   